image: docker:latest

stages:
  - build
  # - test
  - deploy

services:
  - docker:dind

variables:
  NEXT_TELEMETRY_DISABLED: 1

  DOCKER_HOST: tcp://docker:2375
  DOCKER_DRIVER: overlay2

  IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
  IMAGE_TAG_TEST: $CI_REGISTRY_IMAGE:${CI_COMMIT_REF_SLUG}_test

  NODE_ENV: production
  
before_script:
  - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY

after_script:
  - docker info

build:
  stage: build
  script:
    - docker build --pull -t $IMAGE_TAG_TEST .
    - docker push $IMAGE_TAG_TEST

# test:
  # stage: test
  # allow_failure: false
  # script:
  #   - docker run -e $IMAGE_TAG_TEST yarn install
  #   - docker run -e "NODE_ENV=production" $IMAGE_TAG_TEST yarn test:all

deploy:
  stage: deploy
  script:
    - docker pull $IMAGE_TAG_TEST
    - docker tag $IMAGE_TAG_TEST $IMAGE_TAG
    - docker push $IMAGE_TAG
